// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// GetAttachedStickerSetsRequest represents TL type `getAttachedStickerSets#4d9d930d`.
type GetAttachedStickerSetsRequest struct {
	// File identifier
	FileID int32
}

// GetAttachedStickerSetsRequestTypeID is TL type id of GetAttachedStickerSetsRequest.
const GetAttachedStickerSetsRequestTypeID = 0x4d9d930d

// Ensuring interfaces in compile-time for GetAttachedStickerSetsRequest.
var (
	_ bin.Encoder     = &GetAttachedStickerSetsRequest{}
	_ bin.Decoder     = &GetAttachedStickerSetsRequest{}
	_ bin.BareEncoder = &GetAttachedStickerSetsRequest{}
	_ bin.BareDecoder = &GetAttachedStickerSetsRequest{}
)

func (g *GetAttachedStickerSetsRequest) Zero() bool {
	if g == nil {
		return true
	}
	if !(g.FileID == 0) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (g *GetAttachedStickerSetsRequest) String() string {
	if g == nil {
		return "GetAttachedStickerSetsRequest(nil)"
	}
	type Alias GetAttachedStickerSetsRequest
	return fmt.Sprintf("GetAttachedStickerSetsRequest%+v", Alias(*g))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*GetAttachedStickerSetsRequest) TypeID() uint32 {
	return GetAttachedStickerSetsRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*GetAttachedStickerSetsRequest) TypeName() string {
	return "getAttachedStickerSets"
}

// TypeInfo returns info about TL type.
func (g *GetAttachedStickerSetsRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "getAttachedStickerSets",
		ID:   GetAttachedStickerSetsRequestTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "FileID",
			SchemaName: "file_id",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (g *GetAttachedStickerSetsRequest) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getAttachedStickerSets#4d9d930d as nil")
	}
	b.PutID(GetAttachedStickerSetsRequestTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *GetAttachedStickerSetsRequest) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getAttachedStickerSets#4d9d930d as nil")
	}
	b.PutInt32(g.FileID)
	return nil
}

// Decode implements bin.Decoder.
func (g *GetAttachedStickerSetsRequest) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getAttachedStickerSets#4d9d930d to nil")
	}
	if err := b.ConsumeID(GetAttachedStickerSetsRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode getAttachedStickerSets#4d9d930d: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *GetAttachedStickerSetsRequest) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getAttachedStickerSets#4d9d930d to nil")
	}
	{
		value, err := b.Int32()
		if err != nil {
			return fmt.Errorf("unable to decode getAttachedStickerSets#4d9d930d: field file_id: %w", err)
		}
		g.FileID = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (g *GetAttachedStickerSetsRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if g == nil {
		return fmt.Errorf("can't encode getAttachedStickerSets#4d9d930d as nil")
	}
	b.ObjStart()
	b.PutID("getAttachedStickerSets")
	b.Comma()
	b.FieldStart("file_id")
	b.PutInt32(g.FileID)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (g *GetAttachedStickerSetsRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if g == nil {
		return fmt.Errorf("can't decode getAttachedStickerSets#4d9d930d to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("getAttachedStickerSets"); err != nil {
				return fmt.Errorf("unable to decode getAttachedStickerSets#4d9d930d: %w", err)
			}
		case "file_id":
			value, err := b.Int32()
			if err != nil {
				return fmt.Errorf("unable to decode getAttachedStickerSets#4d9d930d: field file_id: %w", err)
			}
			g.FileID = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetFileID returns value of FileID field.
func (g *GetAttachedStickerSetsRequest) GetFileID() (value int32) {
	if g == nil {
		return
	}
	return g.FileID
}

// GetAttachedStickerSets invokes method getAttachedStickerSets#4d9d930d returning error if any.
func (c *Client) GetAttachedStickerSets(ctx context.Context, fileid int32) (*StickerSets, error) {
	var result StickerSets

	request := &GetAttachedStickerSetsRequest{
		FileID: fileid,
	}
	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return &result, nil
}
