// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// GetInstalledStickerSetsRequest represents TL type `getInstalledStickerSets#48642965`.
type GetInstalledStickerSetsRequest struct {
	// Pass true to return mask sticker sets; pass false to return ordinary sticker sets
	IsMasks bool
}

// GetInstalledStickerSetsRequestTypeID is TL type id of GetInstalledStickerSetsRequest.
const GetInstalledStickerSetsRequestTypeID = 0x48642965

// Ensuring interfaces in compile-time for GetInstalledStickerSetsRequest.
var (
	_ bin.Encoder     = &GetInstalledStickerSetsRequest{}
	_ bin.Decoder     = &GetInstalledStickerSetsRequest{}
	_ bin.BareEncoder = &GetInstalledStickerSetsRequest{}
	_ bin.BareDecoder = &GetInstalledStickerSetsRequest{}
)

func (g *GetInstalledStickerSetsRequest) Zero() bool {
	if g == nil {
		return true
	}
	if !(g.IsMasks == false) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (g *GetInstalledStickerSetsRequest) String() string {
	if g == nil {
		return "GetInstalledStickerSetsRequest(nil)"
	}
	type Alias GetInstalledStickerSetsRequest
	return fmt.Sprintf("GetInstalledStickerSetsRequest%+v", Alias(*g))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*GetInstalledStickerSetsRequest) TypeID() uint32 {
	return GetInstalledStickerSetsRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*GetInstalledStickerSetsRequest) TypeName() string {
	return "getInstalledStickerSets"
}

// TypeInfo returns info about TL type.
func (g *GetInstalledStickerSetsRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "getInstalledStickerSets",
		ID:   GetInstalledStickerSetsRequestTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "IsMasks",
			SchemaName: "is_masks",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (g *GetInstalledStickerSetsRequest) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getInstalledStickerSets#48642965 as nil")
	}
	b.PutID(GetInstalledStickerSetsRequestTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *GetInstalledStickerSetsRequest) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getInstalledStickerSets#48642965 as nil")
	}
	b.PutBool(g.IsMasks)
	return nil
}

// Decode implements bin.Decoder.
func (g *GetInstalledStickerSetsRequest) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getInstalledStickerSets#48642965 to nil")
	}
	if err := b.ConsumeID(GetInstalledStickerSetsRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode getInstalledStickerSets#48642965: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *GetInstalledStickerSetsRequest) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getInstalledStickerSets#48642965 to nil")
	}
	{
		value, err := b.Bool()
		if err != nil {
			return fmt.Errorf("unable to decode getInstalledStickerSets#48642965: field is_masks: %w", err)
		}
		g.IsMasks = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (g *GetInstalledStickerSetsRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if g == nil {
		return fmt.Errorf("can't encode getInstalledStickerSets#48642965 as nil")
	}
	b.ObjStart()
	b.PutID("getInstalledStickerSets")
	b.Comma()
	b.FieldStart("is_masks")
	b.PutBool(g.IsMasks)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (g *GetInstalledStickerSetsRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if g == nil {
		return fmt.Errorf("can't decode getInstalledStickerSets#48642965 to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("getInstalledStickerSets"); err != nil {
				return fmt.Errorf("unable to decode getInstalledStickerSets#48642965: %w", err)
			}
		case "is_masks":
			value, err := b.Bool()
			if err != nil {
				return fmt.Errorf("unable to decode getInstalledStickerSets#48642965: field is_masks: %w", err)
			}
			g.IsMasks = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetIsMasks returns value of IsMasks field.
func (g *GetInstalledStickerSetsRequest) GetIsMasks() (value bool) {
	if g == nil {
		return
	}
	return g.IsMasks
}

// GetInstalledStickerSets invokes method getInstalledStickerSets#48642965 returning error if any.
func (c *Client) GetInstalledStickerSets(ctx context.Context, ismasks bool) (*StickerSets, error) {
	var result StickerSets

	request := &GetInstalledStickerSetsRequest{
		IsMasks: ismasks,
	}
	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return &result, nil
}
